
import sys
from os import environ
from os import getcwd
import math
from math import *
import string
import numpy as np
# import scipy.io as sio

sys.path.append(environ["PYTHON_MODULE_PATH"])

pi = math.pi



import CompuCellSetup


sim,simthread = CompuCellSetup.getCoreSimulationObjects()
        
# add extra attributes here
# At this point every time a new cell is created 
# it is going to have a additional list attribute attached to it. 
# Using this later in the Steppable it creates a list which can  be 
# Accesed as
# list_attrib=CompuCell.getPyAttrib(cell)
# As : cellDict=CompuCell.getPyAttrib(cell)
# All elements of this list can now be accessed as
# cellDict["Starv"]

pyAttributeAdder,dictionaryAdder=CompuCellSetup.attachDictionaryToCells(sim)        
CompuCellSetup.initializeSimulationObjects(sim,simthread)

# Definitions of additional Python-managed fields go here
        
#Add Python steppables here
#steppableRegistry=CompuCellSetup.getSteppableRegistry()
from PySteppables import SteppableRegistry
steppableRegistry=SteppableRegistry()

# This is the tumor growth steppable       
from TumorGrowthSteppables import TumorGrowthSteppable
TumorGrowthSteppables=TumorGrowthSteppable(sim,1)
# TumorGrowthSteppables.initParameters(parameters)
steppableRegistry.registerSteppable(TumorGrowthSteppables)
        

from TumorGrowthSteppables import MitosisSteppable
mitosisSteppable=MitosisSteppable(sim,1)
# mitosisSteppable.initParameters(parameters)
steppableRegistry.registerSteppable(mitosisSteppable)


from TumorGrowthSteppables import CellStateTransition
cellStateTransition=CellStateTransition(sim,1)
# cellStateTransition.initParameters(parameters)
steppableRegistry.registerSteppable(cellStateTransition)


from TumorGrowthSteppables import StravHealthCalculator
stravHealthCalculator=StravHealthCalculator(sim,1)
# stravHealthCalculator.initParameters(parameters)
steppableRegistry.registerSteppable(stravHealthCalculator)


from TumorGrowthSteppables import EpithelialSheetSteppable
epithelialSheetSteppable=EpithelialSheetSteppable(sim,1)
# epithelialSheetSteppable.initParameters(parameters)
steppableRegistry.registerSteppable(epithelialSheetSteppable)


from TumorGrowthSteppables import SBMLSolverSteppable
sBMLSolverSteppable=SBMLSolverSteppable(sim,1)
# sBMLSolverSteppable.initParameters(parameters)
steppableRegistry.registerSteppable(sBMLSolverSteppable)


from TumorGrowthSteppables import DataOutput
instanceOfDataOutput=DataOutput(_simulator=sim,_frequency=10)
steppableRegistry.registerSteppable(instanceOfDataOutput)

CompuCellSetup.mainLoop(sim,simthread,steppableRegistry)
        
        
